<?php
include_once("config.php");

class vote{
/*
vote类说明

//Copyleft by Felix021 @ http://www.198880711.com

1.  实例化时会调用构造函数,必须保证包含了config.php, 如: include("config.php");
    config.php中需要包含$dbhost, $dbuser, $dbpass, $dbname, $tblprefix, $interval,
    $votelimit, $starttime, $finishtime, $GMT, $exts, $uploaddir, $map, $rootname, 
    $rootpass, $votesatstart等16个变量.
    
2.  该类使用$map记录字段的名称和数量, 在$map中用//分割字段的名称, 在数据库的
    candidate表中按顺序对应item0, item1, ... , item9. 最多10个字段.
     
2.  使用方法:
     首先安装: 在获得了数据库的用户名和密码后上传投票系统, 执行install.php进行安装该程序会
                自动创建必须的配置文件和数据库中的表
     安装完毕: 为保证安全必须将install.php删除或重命名(至少不应该还是.php文件)

3.  此类的使用方法

    //实例化
    $v1 = new vote;

    //设置初值, 可以只设置前面的值,后面的字段可以空着; 如果不想修改某字段, 则在该
    //位置填入false, 如 $v1->set("1.jpg", false, "2", false, "3");
    $v1->set($items, $file, $vote);
    $items应该是一个数组, 如: $items = array("1", "2", "3", "4");
     若不想更新数组中的某个值，将该值设置为false, 如: $items = array("1", false, "3", "4");
     若不想更新数组, 则可直接用false代替数组, 如: $v1->set(false, $file, $vote);
　 　$file 和 $vote 也可以用 false 代替, 若值为false则不更新, 如: $v1->set(false, false, 5);
　 　可以省略$vote或甚至同时省略$file和$vote, 但不可只省略$file, 如: $v1->set(items);
　 　
    
    //从数据库中读取数据进行初始化
    $v1->init($id);
    
    //插入新数据
    $v1->set(xxxxxx);//先设置初值, 使用方法如上
    $v1->insert();//执行完毕后v1即对应该数据
    
    //更新数据, 
    //需先置候选人id, 如$v1->init(1) 或 $v1->id = 1;
    $v1->set(xxxxxx);//修改值,如果不想修改某字段, 则在该位置填入false
    $v1->update();//更新完毕后v1即对应该数据
    
    //删除数据
    $v1->delete($id);
    e.g. $v1->delete(1);//删除第一个
    
    //取得最后插入的候选人id
    $maxid = $v1->maxid();
    
    //投票. 投票的规则是在$interval(config.php)规定的时间内不能给
    //$votelimit个人投票, 也不能给同一个人投票.    
    $v1->vote($id);
    e.g.  $v1->vote(1); //给第一个人投票
    
    //上传文件
    //先建立表单如下:
    <form enctype="multipart/form-data" method="post" action="Your URL">
        <!-- 注意file要用 name="file"  -->
        <input type="file" name="file"/>
        <input type="submit" value="提交"/>
        <!-- 可继续扩展添加其他数据 -->
    </form>
    //然后在处理表单的位置加上下句即可：
    $v1->uploadfile($id);
    e.g. $v1->uploadfile(1); //上传文件并更新至第一个人的数据中
    
    //列出所有id, 默认案id升序
    $v1->count(排序字段名, 升序/降序);
    e.g.
      $v1->count();//按id升序
      $v1->count("votes", "asc");//按票数升序
      $v1->count("votes, id", "desc");//按先票数后id降序
    
    //html编码字段内容，方便输出，避免html代码被浏览器解析
    //不建议在更新之前使用
    $v1->htmlencode($list);
    //$list: 最多由10位构成的<字符串>, 每一位为一个0~3之间数字, 若忽略, 则默认为"1111111111"
        0: items[$i]不编码
        1: items[$i]编码显示名称和内容
        2: items[$i]编码内容
        3: items[$i]编码显示名称
    e.g. 
        $v1->htmlencode("1111111111");//编码所有items[0]~items[9]的显示名称和内容
        $v1->htmlencode("11011"); //编码0,1,3,4的名称和内容，忽略3和5~9
        $v1->htmlencode("0123"); //忽略0, 编码1的显示名称和内容, 编码2的内容, 编码3的显示名称, 忽略4~9
        
    //去除提交表单时系统自动添加的反斜杆\
    //!!!! 不能在更新之前去除, 否则如果有转义字符mysql会报错 !!!!
    $v1->stripslash($list);
    //$list: 最多由10位构成的<字符串>, 每一位为0或1, 若忽略, 则默认为"1111111111"
        0: items[$i]不去除斜杆
        1: items[$i]去除斜杆
    e.g.
        $v1->stripslash();//去除所有斜杆
        $v1->stripslash("001"); //只去除items[2]的斜杆, 忽略0,1,3~9
    
4.  错误处理:
     应该在每一项操作后检查$v1->valid是否为true; 如果为false, 表示操作失败
     可从$v1->errorstr读取错误信息字符串.

*/
var $conn;  //链接
var $candidatetbl; //候选人数据表名
var $iptbl; //ip数据表名
var $interval; //投票时间间隔
var $valid; //有效性标志(true|false)
var $errorstr; //出错时的错误描述
var $status; //投票状态 0-未开始 1-进行中 2-结束
var $statusstr; //投票状态描述字符串
var $timestr; //间隔时间描述字符串
var $exts; //允许上传的文件扩展名数组
var $countid;
var $ids;

var $id;
var $votes; //票数
var $file; //文件地址
var $itemcount; //设置显示几个字段
var $items; //自定义字段,数组  items[i]['name']为显示名称, items[i]['value']为值, 下同

//构造函数, 设置数据库连接的基本参数
function __construct(){
    global $dbhost, $dbuser, $dbpass, $dbname, $tblprefix, $interval, $starttime, $finishtime, $GMT, $exts, $map;
    if(file_exists("install.php")){
        $this->valid = false;
        $this->errorstr = "为确保安全请及时删除install.php";
        die($this->errorstr);
        return;
    }
    $this->candidatetbl = $tblprefix . "candidate";
    $this->iptbl = $tblprefix . "ip";
    $this->interval = $interval;
    $this->conn = new mysqli($dbhost, $dbuser, $dbpass, $dbname);
    if($this->conn){
        $this->valid = true;
        @$this->conn->query("SET NAMES 'utf8'");
        $current = time();
        $start = strtotime($starttime) + ($GMT+0) * 3600;
        $finish = strtotime($finishtime) + ($GMT+0) * 3600;
        if($current < $start){
            $this->status = 0;
            $this->statusstr = "未开始";
        }else if($current > $finish){
            $this->status = 2;
            $this->statusstr = "已结束";
        }else{
            $this->status = 1;
            $this->statusstr = "进行中";
        }
        
        $this->itemcount = 0;
        $map = explode("//", $map);
        foreach($map as $itemname){
            $itemname = trim($itemname);
            if(empty($itemname)) continue;
            $this->items[$this->itemcount]['name'] = $itemname;
            $this->itemcount++;
            if($this->itemcount == 10)break;//最多10个字段
        }
        
        if($interval < 3600){
            $this->timestr = round($interval / 60, 2) . "分钟";
        }else{
            $h = floor($interval / 3600);
            $m = round(($interval - $h * 3600) / 60, 2);
            $this->timestr = $h . "小时" . $m . "分钟";
        }
        $this->exts = explode(" ", $exts);
        foreach($this->exts as &$ext){
            $ext = trim(strtolower($ext));
        }
        
    }else{
        $this->valid = false;
        $this->errorstr = "Connection failed in __construct: " . mysqli_error($this->conn);
    }
}//end of function __construct()

//析构函数,释放数据库资源
function __destruct(){
    @mysqli_close($this->conn);
}//end of function __destruct()

function count($orderby = "id", $order = "asc"){
    if($order != "desc")$order = "asc";
    if($orderby != "id" && $orderby !="votes" && $orderby !="file"){
        $tmp = substr($orderby, 4);
        if(is_numeric($tmp) === false){
            $orderby = "id";
        }else{
            $tmp += 0;
            if(tmp<0 || tmp >9){
                $orderby = "id";
            }
        }
    }
    $conn = $this->conn;
    $query = "select id from {$this->candidatetbl} where 1 order by {$orderby} {$order}";
    $result = $conn->query($query);
    if($result){
        $this->valid = true;
        $this->countid = $result->num_rows;
        while($row = $result->fetch_assoc()){
            $this->ids[] = $row['id'];
        }
        return true;
    }else{
        $this->valid = false;
        $this->errorstr = "Error in vote::count(): 无法查询数据库"  . mysqli_error($this->conn);
        return false;
    }
}

//初始化函数, 根据id获取字段的值
function init($id){
    if($id === ""){
        $this->valid = false;
        $this->errorstr = '调用vote::init($id)时请设置$id';
        return;
    }
    $conn = $this->conn;
    $query = "select * from {$this->candidatetbl} where id={$id}";
    $db = $conn->query($query);
    if($db === false){
        $this->valid = false;
        $this->errorstr = "Error in vote::init(): " . mysqli_error($conn);
        return;
    }else{
        $num_rows = $db->num_rows;
        if($num_rows == 0){
            $this->valid = false;
            $this->errorstr = "无id({$id})对应的数据";
            return;
        }
        $this->valid = true;
        $row = $db->fetch_assoc();
        $this->id = $row['id'];
        $this->votes = $row['votes'];
        $this->file = $row['file'];
        
        for($i = 0; $i < $this->itemcount; $i++){
            $pointer = "item" . $i;
            $this->items[$i]['value'] = $row[$pointer];
        }
    }
}//end of function init()

//返回当前最大的id
function maxid(){
    $conn = $this->conn;
    $query = "select max(id) as maxid from {$this->candidatetbl}";
    $db = $conn->query($query);
    if($db === false){
        $this->valid = false;
        $this->errorstr = "Error in vote::maxid(): " . mysqli_error($conn);
        return;
    }else{
        $num_rows = $db->num_rows;
        if($num_rows == 0){
            $this->valid = false;
            $this->errorstr = "Error in vote::maxid(): " . "无对应的数据";
            return;
        }
        $this->valid = true;
        $row = $db->fetch_assoc();
        $maxid = $row['maxid'];
        if(empty($maxid))$maxid = 0;
        return $maxid;
    }
}//end of function maxid()

//设置值, items应该为一个数组. 如果不想更新某个值, 将数组中的该值设为false
function set($items = false, $file = false, $votes = false){
    if($file !== false) $this->file = $file;
    if($votes !== false) $this->votes = $votes;
    if($items === false) return;
    for($i = 0; $i < $this->itemcount; $i++){
        if($i >= count($items)){
            break;
        }
        if($items[$i] === false){
            continue;
        }else{
            $this->items[$i]['value'] = $items[$i];
        }
    }
}//end of function set()

//插入函数, 新建一个候选人
function insert(){
    $this->id = $this->maxid() + 1;
    $conn = $this->conn;
    $query = "insert into {$this->candidatetbl} (file)values(\"\")";
    $result = $conn->query($query);
    if($result){
        $this->valid = true;
        $this->update();
    }else{
        $this->valid = false;
        $this->errorstr = "Error in vote::insert(): " . "无法插入新数据, "  . mysqli_error($this->conn);
    }
}//end of function insert()

//更新函数
function update(){
    $conn = $this->conn;
    if(!empty($this->votes)){
        $origvotes = $this->votes;
        $query = "update {$this->candidatetbl} set votes={$this->votes} where id={$this->id}";
        $result = $conn->query($query);
        if($result === false){
            $this->valid = false;
            $this->errorstr = "Error in vote::update(): " . "无法更新字段votes, " . mysqli_error($this->conn);
            $this->votes = $origvotes;
            return;
        }
    }
    if(!empty($this->file)){
        $origfile = $this->file;
        $query = "update {$this->candidatetbl} set file='{$this->file}' where id={$this->id}";
        $result = $conn->query($query);
        if($result === false){
            $this->valid = false;
            $this->errorstr = "Error in vote::update(): " . "无法更新file, " . mysqli_error($this->conn);
            $this->file = $origfile;
            return;
        }
    }
    $origitems = $this->items;
    for($i = 0; $i < $this->itemcount; $i++){
        if(!empty($this->items[$i]['value'])){
            $query = "update {$this->candidatetbl} set item{$i}='{$this->items[$i]['value']}' where id={$this->id}";
            $result = $conn->query($query);
            if($result === false){
                $this->valid = false;
                $this->errorstr = "Error in vote::insert(): " . "无法更新item{$i} " . $v1->items[$i]['name'] . ", " . mysqli_error($this->conn);
                $this->items = $origitems;
                return;
            }
        }
    }
    $this->valid = true;
}//end of function update()

function delete($id){
    if($id === ""){
        $this->valid = false;
        $this->errorstr = '"Error in vote::delete(): " . 调用vote::delete($id)时请设置$id';
        return;
    }
    $conn = $this->conn;
    $query = "delete from {$this->candidatetbl} where id={$id}";
    @$conn->query($query);
    $this->init($id);
    if($this->valid === false){
        $this->valid = true;
    }else{
        $this->errorstr = "Error in vote::delete(): " . "无法删除, " . mysqli_error($this->conn);
    }
}//end of function delete()


function vote($id){
    global $interval, $votelimit;
    $timestr = $this->timestr;
    $this->init($id);
    if($this->valid === false)return;
    if($this->status != 1){
        $this->valid = false;
        $this->errorstr = $this->status == 0 ? "投票尚未开始":"投票已经结束";
        return;
    }
    if(isset($_POST['vcode']) && isset($_SESSION['vcode'])){
        $vcode1 = strtolower(trim($_POST['vcode']));
        $vcode2 = strtolower(trim($_SESSION['vcode']));
        if($vcode1 !== $vcode2){
            $this->valid = false;
            $this->errorstr = "验证码错误";
            return;
        }
    }
    $conn = $this->conn;
    $ip = $_SERVER['REMOTE_ADDR'];
    $time = time() - $interval;
    $query = "select * from {$this->iptbl} where ip='{$ip}' and time>={$time} order by id desc limit 0, {$votelimit}";
    $result = $conn->query($query);
    if($result === false){
        $this->valid = false;
        $this->errorstr = "读取ip数据出错";// . mysqli_error($this->conn);
        return;
    }else if($result->num_rows >= $votelimit){
        $this->valid = false;
        $this->errorstr = "{$timestr}内最多只能给{$votelimit}人投票";
        return;
    }else if($result->num_rows > 0){
        while($row = $result->fetch_assoc()){
            $ids[] = $row['cid'];
        }
        if(in_array($id, $ids)){
            $this->valid = false;
            $this->errorstr = "{$timestr}内不能重复给同一候选人投票";
            return;
        }
    }
    
    
    $this->votes++;
    $query = "update {$this->candidatetbl} set votes={$this->votes} where id={$this->id}";
    $result = $conn->query($query);
    if($result === false){
        $this->valid = false;
        $this->errorstr = "无法更新票数";
        return;
    }
    $query = "insert into {$this->iptbl} (cid, ip, time) values ({$id}, '{$ip}', ". time() .")";
    $result = $conn->query($query);
}//end of function vote()


//提取文件扩展名的小函数
function ext($filename){
    $i = strlen($filename);
    while(substr($filename, $i, 1) != "." && $i >= 0)$i--;
    if($i >= 0){
        return substr($filename, $i + 1);
    }else{
        return "";
    }
}//end of function ext()

//处理表单上传文件并更新至数据库
function uploadfile($id, $file = "file"){
    $this->init($id);
    if($this->valid === false) return;
    $ext = strtolower($this->ext($_FILES[$file]['name']));
    if(in_array(strtolower($ext), $this->exts) ===  false){
        $this->valid = false;
        $this->errorstr = "Error in vote::uploadfile(): " . "不允许的文件类型: {$ext}";
        return;
    }
    $uploadfile = "attachment/{$id}_" . time() . ".{$ext}";
    if(!file_exists("attachment")) {@mkdir("attachment");@unlink("attachment");}
    if(file_exists($uploadfile)) @unlink($uploadfile);
    $res = move_uploaded_file($_FILES[$file]['tmp_name'], $uploadfile);
    if ($res){
        $origfile = $this->file;
        $query = "update {$this->candidatetbl} set file='{$uploadfile}' where id={$id}";
        $result = $this->conn->query($query);
        if($result){
            $this->valid = true;
            @unlink($origfile);
            return;
        }else{
            $this->file = $origfile;
            $this->valid = false;
            $this->errorstr = "Error in vote::uploadfile(): " . "无法更新数据库, " . mysqli_error($this->conn);
            return;
        }
    }else{
        $this->valid = false;
        $this->errorstr = "Error in vote::uploadfile(): " . "文件上传失败!";
        return;
    }
}//end of function uploadfile()


//编码函数，防止输出中有html代码
function htmlencode($list = "1111111111"){
    for($i = 0; $i < $this->itemcount; $i++){
        if($i >= strlen($list)){
            break;
        }
        $bit = substr($list, $i, 1);
        if($bit == "1"){//编码显示名称和内容
            $this->items[$i]['name'] = htmlspecialchars($this->items[$i]['name']);
            $this->items[$i]['value'] = htmlspecialchars($this->items[$i]['value']);
        }elseif($bit == "2"){//只编码内容
            $this->items[$i]['value'] = htmlspecialchars($this->items[$i]['value']);
        }elseif($bit == "3"){//只编码名称
            $this->items[$i]['name'] = htmlspecialchars($this->items[$i]['name']);
        }
    }
}//end of function htmlencode()

//去除提交时多添加的\, 不能在更新之前去除, 否则如果有转义字符mysql会报错!!
function stripslash($list = "1111111111"){
    for($i = 0; $i < $this->itemcount; $i++){
        if($i >= strlen($list)){
            break;
        }
        $bit = substr($list, $i, 1);
        if($bit == "1"){//编码显示名称和内容
            $this->items[$i]['value'] = stripslashes($this->items[$i]['value']);
        }
    }
}//end of function stripslash()

};//end of class vote

?>
